#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<alloc.h>
#include<process.h>

struct node
{ int info;
  struct node *link;
};

typedef struct node * nptr;

nptr getnode()
{ nptr x = (nptr) malloc(sizeof(struct node));
  if(!x) printf("out of mem");
return x;
}

nptr insert(int item, nptr first)
{  nptr temp,prev,cur;

   temp = getnode();
   temp->info = item;
   temp->link = NULL;

   if(first==NULL) return temp;

   if(item<first->info)
   { temp->link = first;
     return temp;
   }


   prev = NULL;
   cur = first;

   while(cur!= NULL && item >cur->info)
   {  prev = cur;
      cur = cur->link;
   }

   prev->link = temp;
   temp->link = cur;

   return first;

}


int hash(int a[],int n)
{  int big,i;

   big = a[0];
   //find the largest in array

   for(i=1;i<n;i++)
   {  if(a[i]>big) big = a[i];
   }

   i = log10(big);

   return pow(10,i);
}





//also address calc sort / heap sort ?

void hash_sort(int a[],int n)
{
  nptr b[10],temp;

  int i,j,digit,hash_value;

  hash_value = hash(a,n);

  for(i=0;i<10;i++)  b[i] = NULL;

  for(i=0;i<n;i++)
   { digit = a[i] / hash_value;
     b[digit] = insert(a[i],b[digit]);
   }

   for(i=j=0;i<10;i++)
   {  temp = b[i];
      while( temp != NULL)
      {  a[j++] = temp->info;
	 temp= temp->link;
      }
   }

}




void main()
{
  int a[40],n,i;

  clrscr();

  scanf("%d",&n);

  for(i=0;i<n;i++)
  scanf("%d",&a[i]);

  hash_sort(a,n);

  for(i=0;i<n;i++)
  printf("%d ",a[i]);

}
