#include<stdio.h>
#include<conio.h>
#include<ctype.h>
#include<process.h>
#include<alloc.h>
#include<math.h>
#include<string.h>

#define STACK_SIZE 20

struct node
{ char info;
  struct node * l, *r;
};

typedef struct node* nptr;

nptr getnode()
{ nptr x = (nptr) malloc(sizeof(struct node));
  if(!x) printf("out of mem");
return x;
}

nptr create_tree(char post[])
{ nptr temp,st[20];
  int i,k;
  char symbol;

  for(i=k=0; (symbol = post[i]) != '\0'; i++)
  {
    temp = getnode();
    temp->info = symbol;
    temp->l = temp->r = NULL;

    if(isalnum(symbol)) st[k++] = temp;

    else
    {  temp->r = st[--k];
       temp->l = st[--k];
       st[k++] = temp;
    }
 }
 return st[--k];  //root of expn tree
}


float eval(nptr root)
{  float num;
   switch(root->info)
   {
     case '+' : return eval(root->l) + eval(root->r);
     case '-' : return eval(root->l) - eval(root->r);
     case '*' : return eval(root->l) * eval(root->r);
     case '/' : return eval(root->l) / eval(root->r);
     case '^' : case '$' : return pow(eval(root->l),eval(root->r));

    default :
      if(isalpha(root->info))
      { printf("%c = ",root->info);
	scanf("%f",&num);
	return num;
      }
      else
	 return root->info - '0';
    }
}

void main()
{ char post[40];
   float res;
   nptr root = NULL;

  clrscr();

  scanf("%s",post);

  root = create_tree(post);
  res = eval(root);

  printf("%f",res);
}

