#include<stdio.h>
#include<conio.h>
#include<alloc.h>
#include<process.h>

struct node
{ int info;
  struct node *l,*r;
  int rthread;
};

typedef struct node * nptr;

nptr getnode()
{ nptr x = (nptr) malloc(sizeof(struct node));
  if(!x) printf("out of mem");
return x;
}

nptr in_succ(nptr x)
{ nptr temp;
  temp = x->r;
  if(x->rthread ==1 ) return temp;

  while(temp->l != NULL) //obtain leftmost node in right subtree
  { temp = temp->l;
  }

  return temp;

}

void inorder(nptr head)
{ nptr temp;
 if(head->l == head)
 { printf("Empty"); return; }

 printf("The traversal is :");
 temp = head;

 for(;;)
 { temp = in_succ(temp);
 if (temp == head) return;
 printf("%d ",temp->info);
 }
}


void insert_left(int item, nptr x)
{ nptr temp= getnode();
temp->info = item;
x->l = temp;
temp->l = NULL;
temp->r = x;
temp->rthread = 1;
}

void insert_right(int item, nptr x)
{ nptr rn,temp= getnode();
temp->info = item;

rn = x->r;
x->r = temp;
x->rthread = 0;
temp->l =  NULL;
temp->r = rn;
temp->rthread = 1;
}

nptr insert(int item, nptr head)
{ char direction;
 nptr cur;

 if(head->l == NULL)
 { insert_left(item, head); return head; }

 cur = head->l;
 for(;;)
 { printf("Insert %d towards left",item);
  printf(" or right of %d (l/r) ",cur->info);

  direction = getche();
  printf("\n");

  if(direction == 'l')
  {  if(cur->l == NULL)
    {  insert_left(item,cur);
	return head;
    }
    else
       cur = cur->l;
    }
  else
  {  if(cur->rthread == 1)
     { insert_right(item, cur);
	return head;
     }
     else
       cur = cur->r;
  }
 }
}





void main()
{
 nptr head;
 int choice,item;

 clrscr();

 head = getnode();
 head->r = head;
 head -> l = NULL;
 head -> rthread = 0;
 for(;;)
 { printf("1) insert 2) inorder 3) exit :");
   scanf("%d",&choice);

   switch(choice)
   { case 1: scanf("%d",&item);
	     head = insert(item,head);
	     break;
     case 2: inorder(head);
	     printf("\n");
	     break;
     default :
	     exit(0);

     }
   }
 }

/*nptr in_pred(nptr x)
{ nptr temp;
  temp = x->r;

  if(x->l ==1 ) return temp;

  while(temp->r != NULL)  //find rightmost node in left subtree
  {  temp = temp->r;
  }

  return temp;
}
*/






